<!DOCTYPE html>
<html lang="en">

<head> 
  <title>Task 29.20</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body onload="onPageLoading()">
  <div class="container">
    <h2 class="text-center">Danh sách người dùng đăng ký</h2>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gJSON_USER = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;
    // parsing json to object
    var gUserListObject = JSON.parse(gJSON_USER);
    
    const gEND_ROW_TABLE = -1;
    // hằng số số thứ tự các cột
    const gCOLUMN_USER_ID = 0;
    const gCOLUMN_FIRSTNAME = 1;
    const gCOLUMN_LASTNAME = 2;
    const gCOLUMN_AGE = 3;
    const gCOLUMN_ACTION = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện loading
    function onPageLoading() {
      // hiển thị dữ liệu lên table
      showDataOnTable(gUserListObject.users);
    }

    // Hàm xử lý sự kiện click vào nút Chi tiết
    function onBtnChiTietClick(paramHTMLElement){
      console.log ("Nút chi tiết được ấn");
      // bienThe.getAttribute("tenThuocTinh"): Lấy giá trị của thuộc tính tenThuocTinh của thẻ.
      var vUserId = paramHTMLElement.getAttribute("data-userid");
      console.log ("User ID: " + vUserId);

      var vUserFirstname = paramHTMLElement.getAttribute("data-firstname");
      console.log ("Firstname: " + vUserFirstname);

      //var vUserLastname = paramHTMLElement.getAttribute("data-lastname");
      var vUserLastname = paramHTMLElement.dataset["lastname"];
      console.log("Lastname: " + vUserLastname);

      var vUserAge = paramHTMLElement.getAttribute("data-age");
      console.log ("Age: " + vUserAge);
    }
     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
     // hiển thị dữ liệu lên table
    function showDataOnTable(paramUserList) {
      var vTable = document.getElementById("user-table");
      // vTable: Biến chứa thẻ table có id = "user-table"
      // vTable.getElementsByTagName("tên_thẻ"): Lấy danh sách các thẻ con trong biến vTable có tên thẻ là tham số đầu vào, vd: tbody
      // .... [0]: Đại diện cho thẻ đầu tiên được tìm thấy
      var vTableBody = vTable.getElementsByTagName("tbody")[0]; // Lấy thẻ tbody đầu tiên trong bảng và đặt vào vTableBody.

      for (var bIndex = 0; bIndex < paramUserList.length; bIndex++) {
        var vUser = paramUserList[bIndex];
        // tạo dòng mưới cho bẳng và ghi vào các giá trị 
        // Cấu trúc bảng: 1 bảng có nhiều dòng, 1 dòng có nhiều ô.

        var row = vTableBody.insertRow(-1); // insertRow (-1): Chèn 1 dòng vào cuối bảng (vị trí là -1)

        var vCellUserId = row.insertCell(gCOLUMN_USER_ID);  // inserCell(0): Chèn 1 ô vào vị trí đầu tiên (0)
        var vCellFirstname = row.insertCell(gCOLUMN_FIRSTNAME); // Chèn 1 ô vào vị trí 1.
        var vCellLastname = row.insertCell(gCOLUMN_LASTNAME);
        var vCellAge = row.insertCell(gCOLUMN_AGE);
        var vCellAction = row.insertCell(gCOLUMN_ACTION);

        vCellUserId.innerHTML = vUser.userId;
        vCellFirstname.innerHTML = vUser.firstname;
        vCellLastname.innerHTML = vUser.lastname;
        vCellAge.innerHTML = vUser.age;
        //vCellAction.innerHTML = '<button class = "btn btn-primary" onClick = "onBtnChiTietClick(this)">Chi tiết</button>';

        var vChiTietButton = document.createElement ("button");
        vChiTietButton.innerHTML = "Chi tiết";
        // bienTheHTML.setAttribute ("tenThuocTinhHTML", "Gia Tri Dat Vao"); // Đặt giá trị cho 1 thuộc tính HTML của thẻ.
        vChiTietButton.setAttribute ("class", "btn btn-primary");
        vChiTietButton.setAttribute ("onClick", "onBtnChiTietClick(this)");
        vChiTietButton.setAttribute ("data-userid", vUser.userId);
        vChiTietButton.setAttribute ("data-firstname", vUser.firstname);
        vChiTietButton.setAttribute ("data-lastname", vUser.lastname);
        vChiTietButton.setAttribute ("data-age", vUser.age);

        vCellAction.appendChild(vChiTietButton);
      }
    }
    
  </script>

</body>

</html>